################################################################################################################
#    :                                                                       #
# -    GWX                                                                                 #
# -    GWX                                                                         #
# -     Windows 10                                   #
#                                                                                                              #
#  :                                                                                          #
# - AutoRestart:                                                                                               #
#             GWX                                                      #
#            KB3065987 (    Windows 10)#
#                                   #
#                                                                                                              #
# - NoRestart:                                                                                                 #
#             GWX                                                      #
#            KB3065987 (    Windows 10)#
#                                               #
#                                                                                                              #
#     GWX    KB3065987   PSWindowsUpdate  #
################################################################################################################
#                                                                                                              #
# :                                                                                         #
#        www.oszone.net                                                                                        #
#                                                                                                              #
################################################################################################################

param(
  [switch]$AutoRestart,#       
  [switch]$NoRestart #        
)

#        #
######################################################

#  ID      
$myWindowsID = [System.Security.Principal.WindowsIdentity]::GetCurrent()
$myWindowsPrincipal = New-Object System.Security.Principal.WindowsPrincipal ($myWindowsID)

#   
$adminRole = [System.Security.Principal.WindowsBuiltInRole]::Administrator

#       
if ($myWindowsPrincipal.IsInRole($adminRole))
{
  #      -       
  $Host.UI.RawUI.WindowTitle = ": " + $myInvocation.MyCommand.Definition
  $Host.UI.RawUI.BackgroundColor = "DarkBlue"
  Clear-Host
}
else
{
  #       -     

  #    PowerShell
  $newProcess = New-Object System.Diagnostics.ProcessStartInfo "PowerShell";

  #         
  $newProcess.Arguments = $myInvocation.MyCommand.Definition;

  #      
  $newProcess.Verb = "runas";

  #    PoweShell
  [System.Diagnostics.Process]::Start($newProcess);

  #    PowerShell,    
  exit
}

#     PSWindowsUpdate  %WINDIR%\System32\WindowsPowerShell\v1.0\Modules
Write-Host "`n>>>  ..."
$curDir = $MyInvocation.MyCommand.Definition | Split-Path -Parent
Copy-Item -Path "$curDir\PSWindowsUpdate" -Destination "$Env:SystemRoot\System32\WindowsPowerShell\v1.0\Modules" -Recurse -Force
Write-Host ""

#   PSWindowsUpdate    PowerShell
Write-Host "`n>>>  ..."
Import-Module PSWindowsUpdate
Write-Host ""

#    
$ServiceID = Get-WUServiceManager | Select ServiceID #  ID  
$OSv = [double][environment]::osversion.version.tostring(2)
$kbID = "KB3035583" #     
$kbIDn = "3035583" #  
$upkbID = "KB3065987" #        DisableOSUpgrade
$GWXfile = "$Env:SystemRoot\System32\GWX"
$restart = $true #      

#     GWX

$answer = '';
if ($AutoRestart) {
  $answer = 'Y'
}
elseif ($NoRestart) {
  $answer = 'S'
}
while ($answer -ne 'Y' -and $answer -ne 'N' -and $answer -ne 'S') {
  "`n    ' Windows 10'?" | Out-Host
  $answer = Read-Host -Prompt "`n   :`n[Y] -  -   `n[N] -  -     `n[S] -    `n"
}

if ($answer -eq 'Y') {
  #   GWX,  .     ,     .
    Write-Host "`n>>>   GWX   ..."
  $gwxProc = Get-Process GWXUX -ErrorAction SilentlyContinue
  if ($gwxProc) {
    $gwxProc | Stop-Process -Force
  }
  $gwxProc = Get-Process GWX -ErrorAction SilentlyContinue
  if ($gwxProc) {
    $gwxProc | Stop-Process -Force
  }
Write-Host ""
    Write-Host "`n>>>  " $update.KB
  $wusaProc = Start-Process "wusa" "/uninstall /kb:$kbIDn /quiet /norestart" -Wait -Passthru
  if ($wusaProc.ExitCode -eq 0) {
    Write-Host "`n ."
  } elseif ($wusaProc.ExitCode -eq 3010) {
    #  wusa.exe   3010  ,      .
    Write-Host "`n     ."
    $restart = $true
  } else {
    Write-Host -ForeGroundColor Red "`n ."
  }
}
if ($answer -eq 'S') {
  Write-Host "`n>>>   GWX  ..."
  $installed = Test-Path $GWXfile
  if ($installed) {
    Write-Host " ' Windows 10' "
    Write-Host "`n>>>   GWX   "
    $gwxProc = Get-Process GWXUX -ErrorAction SilentlyContinue
    if ($gwxProc) {
      $gwxProc | Stop-Process -Force
    }
    $gwxProc = Get-Process GWX -ErrorAction SilentlyContinue
    if ($gwxProc) {
      $gwxProc | Stop-Process -Force
    }
   Write-Host ""
    foreach ($update in $installed) {
      Write-Host "`n>>>  " $update.KB
      $wusaProc = Start-Process "wusa" "/uninstall /kb:$kbIDn /quiet /norestart" -Wait -Passthru
      if ($wusaProc.ExitCode -eq 0) {
        Write-Host "`n ."
      } elseif ($wusaProc.ExitCode -eq 3010) {
        #  wusa.exe   3010  ,      .
        Write-Host "`n     ."
        $restart = $true
      } else {
        Write-Host -ForeGroundColor Red "`n ."
      }

    }
  }
  else {
      Write-Host "`n ' Windows 10'  "
    }
}
if ($answer -eq 'N') {
  Write-Host -ForeGroundColor Red "`n   GWX  ."
}

#    KB3035583
  Write-Host "`n>>>    KB3035583..."
$tohide = Get-WUList -ServiceID '$ServiceID' -KBArticleID $kbID -IsNotHidden

if ($tohide) {
  Write-Host ($tohide | Format-Table | Out-String)
  foreach ($hide in $tohide) {
    Write-Host "`n " $hide.KB
    Write-Host ($hide | Format-Table | Out-String)
    $hide.IsHidden = $true
  }
}
Write-Host ""

#     KB3065987      
"`n>>>    KB3065987(8)..." | Out-Host
$upinstalled = Get-Content "$Env:SystemRoot\PolicyDefinitions\WindowsUpdate.admx" | Where-Object { $_.Contains("DisableOSUpgrade") }
if ($upinstalled) {
  Write-Host "`n     ."
} else {
  Write-Host "`n     Windows 10    KB3065987`n"

  $answer = '';
  if ($AutoRestart) {
    $answer = 'Y'
  }
  elseif ($NoRestart) {
    $answer = 'Y'
  }
  while ($answer -ne 'Y' -and $answer -ne 'N' -and $answer -ne 'S') {
    $answer = Read-Host -Prompt "`n   :`n[Y] -   KB3065987 (   5  30 )`n[N] -    KB3065987 (   W10   )`n[S] -          `n"
  }

  if ($answer -eq 'Y') {
    Write-Host "`n  KB3065987(8).    5  30 ."
    Get-WUInstall -KBArticleID $upkbID -AcceptAll
  }
  if ($answer -eq 'N') {
    Write-Host -ForeGroundColor Red "`n  KB3065987  ."
  }
  if ($answer -eq 'S') {
    if ($OSv -eq '6.1') {
	Start-Process -FilePath https://support.microsoft.com/ru-ru/kb/3065987
	}
	if ($OSv -eq '6.3'){
	Start-Process -FilePath https://support.microsoft.com/ru-ru/kb/3065988
	}
}
}


#     Windows 10
Write-Host "`n>>>     Windows 10...`n>>>     Windows 10..."
Start-Process "$Env:SystemRoot\System32\reg.exe" "ADD HKLM\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate /v DisableOSUpgrade /t REG_DWORD /d 1 /f" -Wait
Write-Host ""

#   
if ($restart) {
  "`n`n     ." | Out-Host
  $answer = '';
  if ($AutoRestart) {
    $answer = 'Y'
  }
  elseif ($NoRestart) {
    $answer = 'N'
  }
  while ($answer -ne 'Y' -and $answer -ne 'N') {
    $answer = Read-Host -Prompt "`n`n[Y] -  `n[N] -  `n"
  }
  if ($answer -eq 'Y') {
    Restart-Computer -Force
  }
}